Public Class AResponse
    Public ResponseTime As Double
    Public KeyCode As Integer
End Class

Public Class ExpTrial
    Public ParamNames As New Collection
    Public ParamValues As New Collection
    Public ParentTrialList As ExpTrialList
    Public Responses As New Collection

    Sub New(ByVal aTrialList)
        ParentTrialList = aTrialList
    End Sub

    Overridable Sub Run(ByVal i)
    End Sub

    Overridable Sub AddParameter(ByVal ParamName As String, ByVal ParamValue As String)
        ParamNames.Add(ParamName)
        ParamValues.Add(ParamValue, ParamName)
    End Sub

    Overridable Sub DumpD3DpresToFile()
        For Each ParamName As String In ParamNames
            System.IO.File.AppendAllText(ParentTrialList.OutputFilename, ParamValues(ParamName) & vbTab)
        Next
        Dim ind As Integer = 0
        If (Responses.Count > 1) Then
            Dim myresp As AResponse = Responses(1)
            System.IO.File.AppendAllText(ParentTrialList.OutputFilename, myresp.KeyCode & vbTab)
            System.IO.File.AppendAllText(ParentTrialList.OutputFilename, myresp.ResponseTime - ParamValues("TrialStartTime") & vbTab)
            ind = ind + 1
        End If
        For i As Integer = ind To ParentTrialList.MaxNumberOfResponses - 1
            System.IO.File.AppendAllText(ParentTrialList.OutputFilename, vbTab & vbTab)
        Next
    End Sub

    Overridable Sub DumpParamHeadersToFile()
        For Each ParamName As String In ParamNames
            System.IO.File.AppendAllText(ParentTrialList.OutputFilename, ParamName & vbTab)
        Next
        For i As Integer = 0 To ParentTrialList.MaxNumberOfResponses - 1
            System.IO.File.AppendAllText(ParentTrialList.OutputFilename, "KeyCode" & i & vbTab)
            System.IO.File.AppendAllText(ParentTrialList.OutputFilename, "ResponseTime" & i & vbTab)
        Next
    End Sub
End Class

